#pragma once
#include <MainScene/SceneMediator.h>
#include <Utility/Image/Graphic.h>
#include <Utility/KeyConfig/KeyInput.h>

class Graphic;
//class KeyInput;
//--------------------------------------------------------------------------
//	V[x[XNX
//--------------------------------------------------------------------------
class SceneBase
{

public:
	// RXgN^
	SceneBase( SceneMediator& mediator ):
	  mSceneMediator( mediator ){}

	//	zfXgN^
	virtual ~SceneBase(){}

	//	
	virtual void Init() = 0;

	//	XV
	virtual void Update( KeyInput& keyInput ) = 0;

	//	`
	virtual void Draw( Graphic& mGraphic ) = 0;

	//	I
	virtual void Finish() = 0;

protected:

	SceneBase( const SceneBase& other );
	SceneBase& operator = ( const SceneBase other );

	SceneMediator& mSceneMediator;

};
