#include <MainScene/SceneManager.h>
#include <MainScene/TitelScene.h>

//--------------------------------------------------------------------------
//	RXgN^
//--------------------------------------------------------------------------
SceneManager::SceneManager() :
mNowSceneBase( 0 ) ,
mNextSceneBase( 0 ) ,
mSubSceneManager()
{

}

//--------------------------------------------------------------------------
//	fXgN^
//--------------------------------------------------------------------------
SceneManager::~SceneManager()
{
	//	݂̃V[Ǝ̃V[̗폜
	delete mNowSceneBase;
	delete mNextSceneBase;
}

//--------------------------------------------------------------------------
//	
//--------------------------------------------------------------------------
void SceneManager::Init()
{
	//	݂̃V[
	mNowSceneBase->Init();
	mSubSceneManager.Init();
}

//--------------------------------------------------------------------------
//	XV
//--------------------------------------------------------------------------
void SceneManager::Update( KeyInput& keyInput )
{
	//	TuV[SɏIĂȂ
	if( mSubSceneManager.SubSceneEnd() )
	{
		//݂̃V[Abvf[g
		mNowSceneBase->Update( keyInput );
	}
	else
	{
		mSubSceneManager.Update( keyInput );
	}

	//	̃V[NULLł͖
	if( mNextSceneBase != 0 )
	{
		//	݂̏IĂ
		Finish();

		//	݂̃V[폜
		delete mNowSceneBase;

		//	̃V[݂̃V[ɓo^
 		mNowSceneBase = mNextSceneBase;

		//	
		Init();

		//	̃V[ɂ
		mNextSceneBase = 0;
	}

}

//--------------------------------------------------------------------------
//	`
//--------------------------------------------------------------------------
void SceneManager::Draw( Graphic& mGraphic )
{
	//	݂̏̕`揈Ă
	mNowSceneBase->Draw( mGraphic );
	mSubSceneManager.Draw( mGraphic );
}

//--------------------------------------------------------------------------
//	I
//--------------------------------------------------------------------------
void SceneManager::Finish()
{
	//	݂̏̏IĂ
	mNowSceneBase->Finish();
	mSubSceneManager.Finish();
}

//--------------------------------------------------------------------------
//	V[̕ύX
//--------------------------------------------------------------------------
void SceneManager::SceneChange(SceneBase* pSceneBase)
{
	//	nėV[̃V[ɗ\񂷂
	mNextSceneBase = pSceneBase;

}
//--------------------------------------------------------------------------
//	V[̃Zbg
//--------------------------------------------------------------------------
void SceneManager::setScene(SceneBase* pSceneBase)
{
	//	nėV[݂̃V[Ɋi[
	mNowSceneBase = pSceneBase;

}


//--------------------------------------------------------------------------
//	TuV[ւ̐؂ւ
//--------------------------------------------------------------------------
void SceneManager::SubSceneChange( SubSceneBace* pSceneBase )
{
	mSubSceneManager.CheangeScene( pSceneBase );
}