//-------------------------------------------------------------------	
//	TuV[}l[WNX
//-------------------------------------------------------------------
#include <SubScene/SubSceneManager.h>

SubSceneManager::SubSceneManager() :
mNowScene( 0 ) ,
mNextScene( 0 )
{

}

SubSceneManager::~SubSceneManager()
{

}

void SubSceneManager::Init()
{
	if( mNowScene != 0 ) mNowScene->Init();
}

void SubSceneManager::Update( KeyInput& keyInput )
{
	//	݂̃V[AGhtOĂȂ΍XV
	if( mNowScene != 0 && !mNowScene->getEndFlag() )
	{
		mNowScene->Update( keyInput );
	}
	else
	{
		Finish();
		mNowScene = 0;
	}

	
	//	\V[鎞
	if( mNextScene != 0 )
	{
		Finish();
		delete mNowScene;
		mNowScene = mNextScene;
		Init();
		mNextScene = 0;
	}
}

void SubSceneManager::Draw( Graphic& mGraphic )
{
	if( mNowScene != 0 ) mNowScene->Draw( mGraphic );
}

void SubSceneManager::Finish()
{
	if( mNowScene != 0 ) mNowScene->Finish();
}

void SubSceneManager::CheangeScene(SubSceneBace *pSceneBase)
{
	//	݂̃TuV[΁Ã݂V[ɁB
	if( mNowScene == 0 )
	{
		mNowScene = pSceneBase;
	}
	//	ȊOȂΗ\񂷂
	else
	{
		mNextScene = pSceneBase;
	}
}

void SubSceneManager::SetScene( SubSceneBace* pSubSceneBase  )
{
	mNowScene = pSubSceneBase;
}

//-------------------------------------------------------------------
//	֐̊ȒPȐ
//	F
//	߂lF
//-------------------------------------------------------------------
bool SubSceneManager::SubSceneEnd()
{
	//	SẴV[
	if( mNowScene == 0 && mNextScene== 0 )
	{
		return true;
	}
	return false;
}