#ifndef _KEYINPUT_H_
#define _KEYINPUT_H_

//#include <Define/Enum.h>

static const enum InputCode
{
	INPUT_NULL,
	INPUT_DOWN,		// `FbN}XN(L[ or eL[̂QL[)
	INPUT_LEFT,		// `FbN}XN(L[ or eL[̂SL[)
	INPUT_RIGHT,	// `FbN}XN(EL[ or eL[̂UL[)
	INPUT_UP,		// `FbN}XN(L[ or eL[̂WL[)
	INPUT_A,		// `(1){^`FbN}XN(yL[)
	INPUT_B,		// a(2){^`FbN}XN(wL[)
	INPUT_C,		// b(3){^`FbN}XN(bL[)
	INPUT_X,		// w(4){^`FbN}XN(`L[)
	INPUT_Y,		// x(5){^`FbN}XN(rL[)
	INPUT_Z,		// y(6){^`FbN}XN(cL[)
	INPUT_L,		// k(7){^`FbN}XN(pL[)
	INPUT_R,		// q(8){^`FbN}XN(vL[)
	INPUT_START,	// rs`qs{^`FbN}XN(drbL[)
	INPUT_M			// l{^`FbN}XN(Xy[XL[)

};

class KeyInput
{
public:
	//	RXgN^
	KeyInput();

	//	fXgN^
	~KeyInput();

	//	
	void Init();

	//	w肳ꂽL[Ă邩ǂ
	bool GetKeyState( int KeyCode );

	//	w肳ꂽL[ꂽǂ
	bool GetKeyTrigger( int KeyCode );

	//	nꂽL[R[hw肳ꂽԍ̔zɃZbg
	void SetKeyCode( int num, int KeyCode );

	//	nꂽWCpbh̃L[R[hw肳ꂽzԍ̗vfɃZbg
	void SetJoyKeyCode( int num, int KeyCode );

	//static KeyInput& GetInstance();

	//KeyInput& operator = ()

private:


	int JoyKey[15];
	int Key[15];
};


#endif